from edge.services.types.controller import ControllerServiceConf
from edge.support import fs
from edge.webserver.sysconf.uiconf.controller import CtrlUiconf


def decode__controller_service_conf(conf_path: str | None = None) -> ControllerServiceConf:
    """
    :param conf_path:
        /etc/edge/setupstore/admin/actions/systest/0
    :raise JnodeError:
    """
    systest_session_active = CtrlUiconf.get_systest()
    event_policy = CtrlUiconf.get_event_policy()

    if conf_path:
        jnode = fs.load_json3(conf_path, default=dict())
        rw_jnode = jnode.get('rw') or dict()
        cert_jnode = rw_jnode.get('certificate')
    else:
        cert_jnode = None

    return ControllerServiceConf(systest_session_active, event_policy, cert_jnode)
